--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 10.1.03
--  \   \         Application : ISE
--  /   /         Filename : t65_test.vhw
-- /___/   /\     Timestamp : Wed Dec 09 10:32:52 2009
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: t65_test
--Device: Xilinx
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library unisim;
use unisim.vcomponents.all;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY t65_test IS
END t65_test;

ARCHITECTURE testbench_arch OF t65_test IS
    COMPONENT t65_wrap
        PORT (
            ADDR : Out std_logic_vector (15 DownTo 0);
            DATA_O : Out std_logic_vector (7 DownTo 0);
            DATA_I : In std_logic_vector (7 DownTo 0);
            RST : In std_logic;
            IRQ : In std_logic;
            NMI : In std_logic;
            WR_N : Out std_logic;
            BUSENA_N : Out std_logic;
            HALT : In std_logic;
            HALTED : Out std_logic;
            RD_N : Out std_logic;
            SYSCLK : In std_logic
        );
    END COMPONENT;

    SIGNAL ADDR : std_logic_vector (15 DownTo 0) := "0000000000000000";
    SIGNAL DATA_O : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL DATA_I : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL RST : std_logic := '0';
    SIGNAL IRQ : std_logic := '0';
    SIGNAL NMI : std_logic := '0';
    SIGNAL WR_N : std_logic := '0';
    SIGNAL BUSENA_N : std_logic := '0';
    SIGNAL HALT : std_logic := '0';
    SIGNAL HALTED : std_logic := '0';
    SIGNAL RD_N : std_logic := '0';
    SIGNAL SYSCLK : std_logic := '0';

    constant PERIOD : time := 20 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 10 ns;

    BEGIN
        UUT : t65_wrap
        PORT MAP (
            ADDR => ADDR,
            DATA_O => DATA_O,
            DATA_I => DATA_I,
            RST => RST,
            IRQ => IRQ,
            NMI => NMI,
            WR_N => WR_N,
            BUSENA_N => BUSENA_N,
            HALT => HALT,
            HALTED => HALTED,
            RD_N => RD_N,
            SYSCLK => SYSCLK
        );

        PROCESS    -- clock process for SYSCLK
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                SYSCLK <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                SYSCLK <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                -- -------------  Current Time:  15ns
                WAIT FOR 15 ns;
                DATA_I <= "11101010";
                -- -------------------------------------
                -- -------------  Current Time:  75ns
                WAIT FOR 60 ns;
                RST <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  155ns
                WAIT FOR 80 ns;
                RST <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  655ns
                WAIT FOR 500 ns;
                HALT <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  1255ns
                WAIT FOR 600 ns;
                HALT <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  1435ns
                WAIT FOR 180 ns;
                DATA_I <= "10001101";
                -- -------------------------------------
                -- -------------  Current Time:  1515ns
                WAIT FOR 80 ns;
                DATA_I <= "00000110";
                -- -------------------------------------
                -- -------------  Current Time:  2435ns
                WAIT FOR 920 ns;
                HALT <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  2715ns
                WAIT FOR 280 ns;
                HALT <= '0';
                -- -------------------------------------
                WAIT FOR 305 ns;

            END PROCESS;

    END testbench_arch;

